Models/tech2.cs
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace LabMaintanance6.Models
{
    using System;
    using System.Collections.Generic;
    
    public partial class tech2
    {
        public int action_id { get; set; }
        public int complain_id { get; set; }
        public string technicianName { get; set; }
        public string action_description { get; set; }
        public System.DateTime action_date { get; set; }
        public bool status { get; set; }
    
        public virtual Complain Complain { get; set; }
    }
}

Controllers/Teacher/tech2Controller.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Web;
using System.Web.Mvc;
using LabMaintanance6.Models;
using PagedList;
using PagedList.Mvc;

namespace LabMaintanance6.Controllers.Teacher
{
    public class tech2Controller : Controller
    {
        private LabMaintanance4Entities db = new LabMaintanance4Entities();

        // GET: tech2
        public ActionResult Index(int? i)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 1)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            var tech21 = db.tech2.Include(t => t.Complain)
                                .Where(t => t.status == true)
                                .ToList()
                                .OrderByDescending(c => c.action_id) // Order by a specific property, such as Id
                .ToList()
                .ToPagedList(i ?? 1, 3);
            

            return View(tech21);
        }


        // GET: tech2/Details/5
        public ActionResult Create()
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 1)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            var activeComplains = db.Complains.Where(c => c.status == true);
            ViewBag.complain_id = new SelectList(activeComplains, "complain_id", "Name_Of_the_Item");
            return View();
        }


        // POST: tech2/Create
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "action_id,complain_id,technicianName,action_description,action_date")] tech2 tech2,int id)
        {
             // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 1)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            if (ModelState.IsValid)
            {
                tech2.status = true;
                tech2.complain_id = id;
                db.tech2.Add(tech2);
                // Get the list of users with role_id = 2
                var users = db.AllUsers.Where(u => u.role_id == 1 && u.status == true).ToList();

                // Send email to each user
                try
                {
                    foreach (var user in users)
                    {
                        SendEmail(user.email, "Lab Maintanior", "A new Action has been taken. Please review it.");
                    }
                }
                catch (Exception ex)
                {
                    // Log the exception for debugging purposes
                    System.Diagnostics.Debug.WriteLine($"Exception: {ex}");

                    ViewBag.ErrorMessage = "An error occurred while processing your request.";

                    // In this example, we're just continuing the process even if an exception occurs
                }

                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.complain_id = new SelectList(db.Complains, "complain_id", "Name_Of_the_Item", tech2.complain_id);
            return View(tech2);
        }
        private void SendEmail(string recipient, string subject, string body)
        {
            // Configure the SMTP client
            var smtpClient = new SmtpClient("smtp.gmail.com", 587);
            smtpClient.EnableSsl = true;
            smtpClient.UseDefaultCredentials = false;
            smtpClient.Credentials = new NetworkCredential("soumaykanti2859@gmail.com", "ssatuysevdkgrthi");

            // Create the email message
            var message = new MailMessage();
            message.From = new MailAddress("soumaykanti2859@gmail.com");
            message.To.Add(new MailAddress(recipient));
            message.Subject = subject;
            message.Body = body;

            // Send the email
            smtpClient.Send(message);
        }

        public ActionResult Delete(int? id)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 1)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            tech2 tech2 = db.tech2.Find(id);
            if (tech2 == null)
            {
                return HttpNotFound();
            }
            return View(tech2);
        }

        // POST: tech2/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 1)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            tech2 tech2 = db.tech2.Find(id);
            tech2.status = false;
            db.Entry(tech2).State = EntityState.Modified;
            db.SaveChanges();
            return RedirectToAction("Index");
        }


        protected override void Dispose(bool disposing)
        {

            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Views/tech2/Create.cshtml
@model LabMaintanance6.Models.tech2

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/_layout.cshtml";

    var selectedComplainId = ViewBag.SelectedComplainId;
}

<head>
    <style>
        .big-textbox {
            width: 500px; /* Adjust the width as needed */
        }

        textarea.form-control {
            height: 150px; /* Adjust the height as needed */
            resize: vertical; /* Allow vertical resizing of the textarea */
        }

        .table-striped tbody tr:nth-of-type(odd) {
            background-color: #f9f9f9;
        }

        .table-striped tbody tr:nth-of-type(even) {
            background-color: #ffffff;
        }

        h2 {
            margin-top: 30px;
            margin-bottom: 20px;
        }

        .form-control {
            border-radius: 0;
        }

        .text-right {
            text-align: right;
        }

        .btn-default {
            color: #333;
            background-color: #fff;
            border-color: #ccc;
        }

            .btn-default:hover {
                color: #333;
                background-color: #e6e6e6;
                border-color: #adadad;
            }

            .btn-default:active,
            .btn-default.active {
                color: #333;
                background-color: #e6e6e6;
                border-color: #adadad;
            }
    </style>
</head>

<h2>Submit Action Details</h2>

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

    <table class="table table-striped">
     
        <tr>
            <th>Technician Name</th>
            <td>
                @Html.EditorFor(model => model.technicianName, "Technician Name", new { htmlAttributes = new { @class = "form-control", required = "required" } })
                @Html.ValidationMessageFor(model => model.technicianName, "", new { @class = "text-danger" })
            </td>
        </tr>
        <tr>
            <th>Action_Description</th>
            <td class="big-textbox">
                <textarea id="action_description" name="Action Description" class="form-control" required="required"></textarea>
                @Html.ValidationMessageFor(model => model.action_description, "", new { @class = "text-danger" })
            </td>
        </tr>
        <tr>
            <th>Action_Date</th>
            <td>
                @Html.EditorFor(model => model.action_date,"Action Date", new { htmlAttributes = new { @class = "form-control", required = "required" } })
                @Html.ValidationMessageFor(model => model.action_date, "", new { @class = "text-danger" })
            </td>
        </tr>
        <tr>
            <td colspan="2" class="text-right">
                <input type="submit" value="Create" class="btn btn-default" />
            </td>
        </tr>
    </table>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")

    <script>
        // Function to get the current date and time in yyyy-MM-dd HH:mm format
        function getCurrentDateTime() {
            var today = new Date();
            var year = today.getFullYear();
            var month = String(today.getMonth() + 1).padStart(2, '0');
            var day = String(today.getDate()).padStart(2, '0');
            var hours = String(today.getHours()).padStart(2, '0');
            var minutes = String(today.getMinutes()).padStart(2, '0');
            var dateTime = year + '-' + month + '-' + day + ' ' + hours + ':' + minutes;
            return dateTime;
        }

        // Set the current date and time in the action_date field
        $(document).ready(function () {
            var currentDateTime = getCurrentDateTime();
            $('#action_date').val(currentDateTime);
        });
    </script>
}

Views/tech2/Delete.cshtml
@model LabMaintanance6.Models.tech2

@{
    ViewBag.Title = "Delete";
    Layout = "~/Views/Shared/_layout.cshtml";
}



<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Action Record</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            Technician Name
        </dt>

        <dd>
            @Html.DisplayFor(model => model.technicianName)
        </dd>

        <dt>
            Action Description
        </dt>

        <dd>
            @Html.DisplayFor(model => model.action_description)
        </dd>

        <dt>
            Action Date
        </dt>

        <dd>
            @Html.DisplayFor(model => model.action_date)
        </dd>

        <dt>
            Name of the Item
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Complain.Name_Of_the_Item)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

Views/tech2/Index.cshtml
@model IPagedList<LabMaintanance6.Models.tech2>

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_layout.cshtml";
}
@using PagedList;
@using PagedList.Mvc;

<h2>Action List</h2>

<div class="table-responsive">
    <table class="table table-striped">
        <thead>
            <tr>
                <th>Technician Name</th>
                <th>Action Description</th>
                <th>Action Date</th>
                <th>Name of the Item</th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach (var item in Model)
            {
                <tr>
                    <td>@Html.DisplayFor(modelItem => item.technicianName)</td>
                    <td>@Html.DisplayFor(modelItem => item.action_description)</td>
                    <td>@Html.DisplayFor(modelItem => item.action_date)</td>
                    <td>@Html.DisplayFor(modelItem => item.Complain.Name_Of_the_Item)</td>
                    <td>
                        @Html.ActionLink("Delete", "Delete", new { id = item.action_id }, new { @class = "btn btn-danger btn-sm" })
                    </td>
                </tr>
            }
        </tbody>
    </table>
</div>

@Html.PagedListPager(Model, i => Url.Action("Index", "tech2", new { i, search = Request.QueryString["search"] }))